unit main;

{$mode objfpc}{$H+}


interface


uses
  Classes, SysUtils, SpiderCGI, SpiderUtils,
  SpiderTable, SpiderAction, memds, SpiderForm, SpiderPage, SpiderApache, db;


type


  { TDataModule1 }

  TDataModule1 = class(TDataModule)
    MemDataset1: TMemDataset;
    saManualTable: TSpiderAction;
    saDatasettable: TSpiderAction;
    saPage: TSpiderAction;
    saUpload: TSpiderAction;
    saHello: TSpiderAction;
    saRedirect: TSpiderAction;
    saCSS: TSpiderAction;
    SpiderApache1: TSpiderApache;
    SpiderCGI1: TSpiderCGI;
    SpiderForm1: TSpiderForm;
    sfUpload: TSpiderForm;
    SpiderPage1: TSpiderPage;
    SpiderTable1: TSpiderTable;
    SpiderTable2: TSpiderTable;
    stCSS: TSpiderTable;
    procedure DataModuleCreate(Sender: TObject);
    procedure saCSSRequest(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure saDatasettableRequest(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure saHelloRequest(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure saManualTableRequest(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure saPageRequest(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure saRedirectRequest(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure saUploadRequest(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure SpiderApache1Request(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure SpiderCGI1Requestg(Sender: TObject; Request: TSpiderRequest;
      var Response: TSpiderResponse);
    procedure SpiderPage1Tag(Sender: TObject; ATag: string;
      var TagReplacement: string);
  private
    { private declarations }
    procedure Menu(Request: TSpiderRequest; Response: TSpiderResponse);
  public
    { public declarations }
  end; 


var
  DataModule1: TDataModule1; 

implementation

uses
  Mod2, Mod3;

{ TDataModule1 }

{$R *.lfm}

procedure TDataModule1.SpiderCGI1Requestg(Sender: TObject; Request: TSpiderRequest;
  var Response: TSpiderResponse);
begin
  Response.ContentType:= 'text/html; charset=UTF-8';

  Response.Add('<html><title>Free Spider CGI Web Application Sample</title><body>');
  Response.Add('<h2>Free Spider <font color=blue>CGI</font> Sample</h2>');
  Response.Add('<br/>Referer: <font color=gray>' + Request.Referer + '</font>');

  Menu(Request, Response);

end;

procedure TDataModule1.SpiderPage1Tag(Sender: TObject; ATag: string;
  var TagReplacement: string);
begin
  if ATag = 'time' then
    TagReplacement:= DateTimeToStr(Now)
  else
  if ATag = 'table' then
  begin
    if FileExists('/var/tmp/sub.dat') then
      MemDataset1.LoadFromFile('/var/tmp/sub.dat');
    MemDataset1.Open;
    MemDataset1.FieldByName('SubName').DisplayLabel:= 'Name';
    MemDataset1.FieldByName('Address').Visible:= False;
    TagReplacement:= SpiderTable2.Contents;
  end
  else
  if ATag = 'home' then
    TagReplacement:= '<a href="./">Main</a>'
  else
  if ATag = 'month' then
    TagReplacement:= FormatDateTime('mmm', Now)
  else
  if ATag = 'year' then
    TagReplacement:= FormatDateTime('yyyy', Now);
end;

procedure TDataModule1.Menu(Request: TSpiderRequest; Response: TSpiderResponse);
begin
  Response.Add('<P STYLE="background: #cbcbcb">');
  Response.Add('<font size="-2">');
  Response.Add('Current server time is: <b>' + DateTimeToStr(Now) + '</b><br/>');
  Response.Add('Current server software is: <b>' + Request.WebServerSoftware + '</b><br/>');
  Response.Add('Your browser is: <font color=blue>' + Request.UserAgent + '</font><br/>');
  Response.Add('Your IP address is: <font color=blue>' + Request.RemoteAddress + '</font><br/>');

  Response.Add('</font></p>');

  Response.Add('<hr>');

  // Main module
  Response.Add('<a href="' + Request.RootURI + '/hello">Hello World (SpiderAction)</a><br/>');
  Response.Add('<a href="' + Request.RootURI + '/manualtable">Manual Table (SpiderTable)</a><br/>');
  Response.Add('<a href="' + Request.RootURI + '/datasettable">Dataset Table (SpiderTable)(SpiderForm)</a><br/>');
  Response.Add('<a href="' + Request.RootURI + '/page">Page Template(SpiderPage)</a><br/>');
  Response.Add('<a href="' + Request.RootURI + '/upload">Upload/Download file(SpiderForm/Multipart decoder)</a><br/>');


  // Mod2
  Response.Add('<hr>');
  Response.Add('<a href="' + Request.RootURI + '/color">Colour Table (Smart Module Loading design, action exist in Mod2)</a><br/>');
  Response.Add('<a href="' + Request.RootURI + '/mod2ac2">Action2 in Mod2 (Smart Module Loading design, action exist in Mod2)</a><br/>');

  // Mod3
  Response.Add('<hr>');
  Response.Add('<a href="' + Request.RootURI + '/mod3ac1">Module 3 Action 1 (Smart Module Loading design, action exist in Mod3)</a><br/>');
  Response.Add('<a href="' + Request.RootURI + '/cookies">Cookies reader / Writer (Smart Module Loading design, action exist in Mod3)</a><br/>');

  Response.Add('<a href="' + Request.RootURI + '/codesite">Redirection to Code.sd</a><br/>');

  Response.Add('<a href="' + Request.RootURI + '/css">CSS Table sample</a><br/>');

  Response.Add('<hr><i><font size="-4" color=gray>By Motaz Abdel Azeem 2009 2012</font></i>');
  Response.Add('</body></html>');

end;

procedure TDataModule1.DataModuleCreate(Sender: TObject);
begin
  // This will work in case of compiling CGI version of this sample
  SpiderCGI1.AddDataModule('TdmMod2', ['/color', '/mod2ac2']);
  SpiderCGI1.AddDataModule('TdmMod3', ['/mod3ac1', '/cookies']);

  // This will work in case of compiling Apache version of this sample
  SpiderApache1.AddDataModule('TdmMod2', ['/color', '/mod2ac2']);;
  SpiderApache1.AddDataModule('TdmMod3', ['/mod3ac1', '/cookies']);

  // This has no effect in case of Apache Module mode. You can leave it
  SpiderCGI1.Execute;
end;

procedure TDataModule1.saCSSRequest(Sender: TObject; Request: TSpiderRequest;
  var Response: TSpiderResponse);
begin
  Response.ContentType:= 'text/html; charset=UTF-8';
  Response.Add('<!DOCTYPE html>' +
    '<html>' +
    '<head>' +
    '<style type="text/css">' +
    'tr.s1' +
    '{ background:#DDFF99; color:blue; }' +

    'tr.s2 ' +
    '{  background:#EEFFEE; color:red; }' +
    '</style>' +
    '</head>');

  stCSS.SetHeader(['ID', 'Name', 'Degree']);
  stCSS.AddRow('', 'class="s1"', ['1', 'Motaz', '55']);
  stCSS.AddRow('', 'class="s1"', ['2', 'Mohammed', '95']);
  stCSS.AddRow('', 'class="s2"', ['3', 'Ali', '44']);
  Response.Add(stCSS.Contents);
end;

procedure TDataModule1.saDatasettableRequest(Sender: TObject;
  Request: TSpiderRequest; var Response: TSpiderResponse);
begin
  Response.ContentType:= 'text/html; charset=UTF-8';

  SpiderForm1.Action:= Request.RootURI + '/datasettable';
  SpiderForm1.Clear;
  SpiderForm1.AddText('Enter Subscriber ID: ');
  SpiderForm1.AddInput(itText, 'id', '');

  SpiderForm1.AddText('Enter Subscriber Name: ');
  SpiderForm1.AddInput(itText, 'subname', '');

  SpiderForm1.AddText('Address: ');
  SpiderForm1.AddInput(itText, 'address', '');

  SpiderForm1.AddText('Telephone Number: ');
  SpiderForm1.AddInput(itText, 'telephone', '');

  SpiderForm1.AddInput(itSubmit, 'add', 'Add');


  Response.Add(SpiderForm1.Contents);

  if FileExists('sub.dat') then
    MemDataset1.LoadFromFile('sub.dat');

  MemDataset1.Open;

  if Request.ContentFields.IndexOfName('add') <> -1 then
  begin
    Response.Content.Add('Saving data..');
    MemDataset1.Append;
    MemDataset1.FieldByName('ID').AsString:= Request.Form('id');
    MemDataset1.FieldByName('SubName').AsString:= Request.Form('subname');
    MemDataset1.FieldByName('Address').AsString:= Request.Form('address');
    MemDataset1.FieldByName('Telephone').AsString:= Request.Form('telephone');
    MemDataset1.Post;
    MemDataset1.SaveToFile('/var/tmp/sub.dat');
  end;
  Response.Add(SpiderTable2.Contents);
  Response.Add('<hr><a href="./">Main</a>');

end;

procedure TDataModule1.saHelloRequest(Sender: TObject; Request: TSpiderRequest;
  var Response: TSpiderResponse);
begin
  Response.Add('<font color=green>Hello world</font> from FreeSpider Package for Lazarus<br/>');
  Response.Add('The best way for Web development in <b>FreePascal/Lazarus</b>');
  Response.Add('<br/>Referer: <font color=gray>' + Request.Referer + '</font>');
end;

procedure TDataModule1.saManualTableRequest(Sender: TObject;
  Request: TSpiderRequest; var Response: TSpiderResponse);
begin
  Response.ContentType:= 'text/html; charset=UTF-8';
  Response.Add('<html><head><title>Manual Table</title>');
  Response.Add('<style type="text/css">');
  Response.Add('SpiderTable1.cssClass = "myCssClassForTable" ; ' +
    'CSSHeaderTableClass (' +
    'cssClass = "myCssClassForHeader"; ' +
    'array of CSSCellTableClass = CSSCellTableClass("Telephone Number"); ) ' +

    'CSSRowTableClass (' +
    'cssClass = "myCssClassForRow";' +
    'array of CSSCellTableClass ; ) ' +

    'CSSCellTableClass ( ' +
    'cssClass = "myCssClassForCell"; text = "01754341";  ))');
   Response.Add('</style>');

  Response.Add('</head><body>');

  SpiderTable1.TableExtraParams:= 'class="myCssClassForTable"';
  SpiderTable1.HeaderExtraParams:= 'class="myCssClassForHeader"';

  SpiderTable1.SetHeader(['ID', 'Name', 'Telephone Number']);
  SpiderTable1.AddRow(['1', 'Mohammed', '01223311']);
  SpiderTable1.AddRow('#FFEEDD', 'class="myCssClassForCell"', ['2', 'Ahmed', '01754341']);
  SpiderTable1.AddRow('#FFDDEE', ['3', 'Omer', '045667890']);
  Response.Add(SpiderTable1.Contents);

  Response.Add('<br/><br/>This is the code of adding this table:<br/><br/>');


  Response.Add('<font face="Courier New" color=blue size="-2">');
  Response.Add('<P STYLE="background: #b3b3b3">');
  Response.Add('SpiderTable1.SetHeader([''ID'', ''Name'', ''Telephone Number'']);<br/>');
  Response.Add('SpiderTable1.AddRow('''', [''1'', ''Mohammed'', ''01223311'']);<br/>');
  Response.Add('SpiderTable1.AddRow(''#FFEEDD'', [''2'', ''Ahmed'', ''01754341'']);<br/>');
  Response.Add('SpiderTable1.AddRow(''#FFDDEE'', [''3'', ''Omer'', ''045667890'']);<br/>');
  Response.Add('Response.Content.Add(SpiderTable1.Contents);<br/>');
  Response.Add('</font></p>');
  Response.Add('<hr><a href="' + Request.RootURI + '">Home</a></body></html>');
end;

procedure TDataModule1.saPageRequest(Sender: TObject; Request: TSpiderRequest;
  var Response: TSpiderResponse);
begin
  Response.ContentType:= 'text/html; charset=UTF-8';
  if FileExists('/home/motaz/projects/spidersample/page.htm') then
    SpiderPage1.PageFileName:= '/home/motaz/projects/spidersample/page.htm'
  else
  if FileExists('c:\projects\FreePascal\spidersample\page.htm') then
    SpiderPage1.PageFileName:= 'c:\projects\FreePascal\spidersample\page.htm';
  Response.Content.Add(SpiderPage1.Contents);
end;

procedure TDataModule1.saRedirectRequest(Sender: TObject;
  Request: TSpiderRequest; var Response: TSpiderResponse);
begin
  Response.SendRedirect('http://code.sd/freespider/', 'Wait.. redirecting to code.sd');
end;

procedure TDataModule1.saUploadRequest(Sender: TObject;
  Request: TSpiderRequest; var Response: TSpiderResponse);
begin
  if   (Request.FilesCount = 1) then // Download uploaded file
  begin
    Response.ContentType:= Request.ContentFiles[0].ContentType;
    Response.CustomHeader.Add('Content-Disposition: filename="' + Request.ContentFiles[0].FileName + '"');
    Response.Add(Request.ContentFiles[0].FileContent);
    Response.SetCookie('LastUploadedFile', Request.ContentFiles[0].FileName, '/',
      Now - EncodeTime(3, 0, 0, 0) + EncodeTime(0, 5, 0, 0)); // Set cookies for 5 minutes, in a GMT + 3 country

  end
  else // View upload form
  begin
    Response.Add('<h2>File Upload sample</h2>');
    Response.Add('Please select a file to be uploaded to the server<br/>');
    Response.Add('This file will be downloaded after the upload is successed<br/><br/>');
    Response.Add('<font color=gray>An automatic multipart encoded page will be detected from FreeSpider package ');
    Response.Add(' and will be decoded automatically</font><br/><br/>');

    sfUpload.Clear;
    sfUpload.Action:= Request.RootURI + '/upload';
    sfUpload.AddInput(itFile, 'upload');
    sfUpload.AddInput(itSubmit, 'upload', 'Upload');
    Response.Add(sfUpload.Contents);
    Response.Add('<hr><a href="' + Request.RootURI + '">Home</a>');
  end;
end;

procedure TDataModule1.SpiderApache1Request(Sender: TObject;
  Request: TSpiderRequest; var Response: TSpiderResponse);
begin
  Response.ContentType:= 'text/html; charset=UTF-8';

  Response.Add('<html><title>Free Spider Apache Module Web Application Sample with thread pooling</title><body>');
  Response.Add('<h2>Free Spider <font color=green>Apache Module with thread pooling</font> Sample</h2>');
  Response.Add('<br/>Referer: <font color=gray>' + Request.Referer + '</font>');

  Menu(Request, Response);

end;

initialization

end.

